#!/usr/bin/perl
use strict;
use warnings;

use utf8;
use open ':std', ':encoding(UTF-8)';
use Unicode::Normalize;

# *********************************************
# ** put your old and new media paths in here **
# *********************************************
my $old_media_path = "/Users/Shared/Music/Music/";
my $new_media_path = "/media/nas/music/"; 

# Overwrite original m3u file (true), write a second m3u file (false)
my $overwrite = "true";


# *** Ab hier nichts mehr ändern!! ***
# *** Do not change anything beyond this point!! ***

# Filename
my $file_name = $ARGV[0];
my $file_name_out;

# check if ARGV is not empty
if (not defined $file_name)
	{
		print "******************************************\n";
		print "*********** No file name given! **********\n";
		print "*** Usage: convert_playlist <filename> ***\n";
		print "******************************************\n";
		exit;
	}

# Overwrite odr new name with LMS
if ($overwrite eq "true")
{
	$file_name_out = $file_name;
}	
elsif ($overwrite eq "false")
{
	# change to new filename to not overwrite the original file
	my $point_pos = index($file_name,".");
	my $before_point = substr($file_name,0,$point_pos);
	my $behind_point = substr($file_name,$point_pos);
	$file_name_out = $before_point."_LMS".$behind_point;
}

# arrays
my @items = ("");  # all lines of the file
my @media_path = (""); 
my @new_formed_path = ("");
my @extinf = ("");
my @exturl = ("");

# counters
my $i = 0;		# counter1
my $x = 0;		# counter2
my $z = 0;		# counter3
my $y = 0;		# counter4

my $zs;		# cache

# length of old path
my $length_media_path = length($old_media_path);
my $cutted_path;


# programm
# converting Mac line endings(CR) to unix line endings(LF)
my $lineending ="\n";
&convert_mac_file;

# test if file is already converted
&test_file;

# converting the Apple Music Playlist to an LMS compatible playlist
&load_playlist;
&write_playlist($file_name_out);


&output;


# sub programs

# test if file is already converted
sub test_file {
open(EXTURL_TEST,"<$file_name") || die "File $file_name not found!\n";
{
	while(<EXTURL_TEST>)
	{
		if (index($_,"EXTURL") ne "-1")
		{
			print "*******************************\n";
			print "*** File already converted! ***\n";
			print "*******************************\n";
			exit;
		}
	}
}
close(EXTURL_TEST);
}

sub convert_mac_file
{

	# Mac(CR) Playlist einlesen
	open(MAC_FORMAT,"<$file_name") || die "File $file_name not found!\n";
		my @lines = <MAC_FORMAT>;
	close MAC_FORMAT;

	# Zeilenenden umwandeln
	for $y (0..$#lines)
	{
		$lines[$y] =~ s/(\012|\015\012?)/$lineending/g;
	}

	# Unix(LF) Playlist zurückschreiben
	open(UNIX_FORMAT,">converted.txt");
		print UNIX_FORMAT @lines;
	close(UNIX_FORMAT);
}


# load playlist
sub load_playlist {

open(PLAYLIST, "<converted.txt") || die "File $file_name not found!\n";

	while(<PLAYLIST>)
	{

 	$items[$i] = $_;
 
 	if (index($items[$i],$old_media_path) == 0)
 		{
 			$media_path[$x] = $items[$i];
	 		&media_path($x);
 			$x++;
 		}
 	elsif (index($items[$i],"#EXTINF") == 0)
 		{
	    	$extinf[$z] = $items[$i];
	    	$z++;
	 	}
		$i++; 
	}

close(PLAYLIST);

unlink ("converted.txt");

}


# write playlist
sub write_playlist {

open(PLAYLIST_OUT,">$file_name_out") || die "File $file_name_out not found\n";

	$i = 0;

	print PLAYLIST_OUT "#EXTM3U\n";

	for (@exturl)
	{
		print PLAYLIST_OUT "$exturl[$i]";
		print PLAYLIST_OUT "$extinf[$i]";
		print PLAYLIST_OUT "$new_formed_path[$i]";
		$i++;
	}

close(PLAYLIST_OUT);
}

# build the #EXTURL line
sub media_path {
            	
        $cutted_path = substr($media_path[$x],$length_media_path);
        $cutted_path = NFC($cutted_path);
              	
        $new_formed_path[$x] = $new_media_path . $cutted_path;
        
        $zs = urlize($cutted_path);
    	$exturl[$x] = "#EXTURL:file://".$new_media_path.$zs;
}

# Output
sub output {
	print "\n";
	print '*' x length("*** File converted to $file_name_out! ***")."\n";
	print "*** File converted to $file_name_out! ***\n";
	print '*' x length("*** File converted to $file_name_out! ***")."\n";
	print "\n";
}

# build the URI 
sub urlize {
	my ($rv) = @_;
	$rv =~ s/([^A-Za-z0-9\/\\\.\_\-\&\n\(\)])/sprintf("%%%2.2X", ord($1))/ge;
	return $rv;
}
